function openModal(elementId) {
    console.log(elementId);
    const modal = document.getElementById('myModal');
    modal.style.display = 'block';
    const image = document.getElementById(elementId);
    const modalImage = document.getElementById('modal_image');
    modalImage.src = image.src;
    document.getElementById('imgCont').style.display = 'block';
}

function openModalVid(elementId) {
    console.log(elementId);
    const modalVid = document.getElementById('myModalVid');
    modalVid.style.display = 'block';
    const vid = document.getElementById(elementId);
    const modalVideo = document.getElementById('modal_video');
    modalVideo.setAttribute('controls', 'controls');
    modalVideo.src = vid.src;
    document.getElementById('vidCont').style.display = 'block';
}

function closeModal(modalId) {
    const modal = document.getElementById(modalId);
    if (modal && modal.style.display === 'block') {
        modal.style.display = 'none';
    }
}

function adjustCommentSectionHeights() {
    Array.from(document.getElementsByTagName('tr'))
        .filter(el => el.vAlign === 'top' && el.style.height === '157px')
        .forEach(el => el.style.height = '12px');

    Array.from(document.querySelectorAll("[id='action-comment-section']")).forEach(el => {
        const actualHeight = el.clientHeight;
        if (actualHeight > 70) {
            adjustCommentSection(el, actualHeight);
        }
    });
}

function adjustCommentSection(element, height) {
    element.parentElement.style.height = '';
    element.parentElement.parentElement.parentElement.style.height = height;
    const parentLayout = element.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement.parentElement;
    const targetSvg = parentLayout.getElementsByTagName('svg')[0];
    targetSvg.setAttribute('height', height + 100);
    targetSvg.getElementsByTagName('rect')[0].setAttribute('height', height + 100);
    Array.from(parentLayout.getElementsByTagName('span')).filter(el => el.innerText === 'No Image').forEach(el => {
        el.parentElement.style.paddingTop = (height - el.clientHeight) / 2 + 10;
    });
    const icon = parentLayout.getElementsByClassName('api-icon')[0];
    if (icon) {
        icon.style.paddingBottom = height + 55;
        icon.parentElement.style.height = height + 55;
    }
}

function adjustVideoAndImageStyles() {
    adjustVideoStyles();
    adjustImageStyles();
}

function adjustVideoStyles() {
    const videos = Array.from(document.getElementsByTagName('video')).filter(video => video.id !== 'modal_video');
    videos.forEach(video => {
        const parent = video.parentElement.parentElement;
        parent.style.display = 'flex';
        parent.style.alignItems = 'center';
        parent.style.backgroundColor = '';
        parent.parentElement.style.backgroundColor = '';
        parent.parentElement.parentElement.style.backgroundColor = '';
    });
}

function adjustImageStyles() {
    let images = Array.from(document.getElementsByTagName('img'));
    images = images.filter(image => image.title.match(/screen_/));
    if (images.length > 0) {
        images.forEach(image => {
            adjustImage(image);
        });
    }
}

function adjustImage(imageElement) {
    imageElement.setAttribute('id', imageElement.title);
    imageElement.setAttribute('class', 'cursor image-style image');
    imageElement.parentElement.setAttribute('style', 'pointer-events: auto;');
    const topWrapper = createTopWrapper(imageElement);
    const wrapper = createImageWrapper(imageElement);
    const divOverLay = createOverlay(imageElement);
    wrapper.appendChild(divOverLay);
    imageElement.parentNode.replaceChild(wrapper, imageElement);
    topWrapper.appendChild(wrapper.cloneNode(true));
    wrapper.parentNode.replaceChild(topWrapper, wrapper);
    const topParent = topWrapper.parentNode.parentNode.parentNode.parentNode.parentNode;
    if (topParent.clientHeight > 172) {
        topWrapper.style.paddingTop = (topParent.clientHeight - 150) / 2 - 10;
    }
}

function createTopWrapper(imageElement) {
    const topWrapper = document.createElement('div');
    topWrapper.setAttribute('style', 'width:200px;height:150px;display: flex;align-items: center; overflow:hidden;');
    return topWrapper;
}

function createImageWrapper(imageElement) {
    const wrapper = document.createElement('div');
    wrapper.setAttribute('class', 'overlay-image');
    wrapper.appendChild(imageElement.cloneNode(true));
    return wrapper;
}

function createOverlay(imageElement) {
    const divOverLay = document.createElement('div');
    divOverLay.setAttribute('class', 'hover cursor');
    divOverLay.setAttribute('onClick', `openModal('${imageElement.title}')`);
    return divOverLay;
}

function addLinkIconToHrefs() {
    Array.from(document.getElementsByTagName('a'))
        .forEach(el => el.firstChild.className = 'ats-icon-hl-12-grey');
}

document.addEventListener('DOMContentLoaded', function () {
    adjustCommentSectionHeights();
    adjustVideoAndImageStyles();
    addLinkIconToHrefs();
    document.getElementById('loader').style.display = 'none';
});